memcached_lock_default_value

PHP7, memcached, a w tle Phalcon i AJAX

PHP 7 jest już z nami 3 lata. Właśnie wygaszono PHP 7.0 oraz PHP 5.6, czyli nie są już w żaden sposób wspierane przez społeczność pracującą przy core PHP. Statystyki na podstawie pobrań Composera w połowie 2018 roku mówią, że około 80% to już PHP 7.* – jest dobrze można pomyśleć. Aż tu nagle znajduje się pewien problem…

Phalcon

Nie wiem, czy każdy z Was słyszał o Phalconie – frameworku PHP napisanym w C, kompilowanym jako rozszerzenie PECL. W 2016 roku, kilka miesiący po ukazaniu się PHP 7, został opublikowany Phalcon 3.0 z pełnym wsparciem dla PHP 7.0. Prawie każdy o nim mówił, ponieważ samo użycie PHP 7 przyspieszało aplikacje, a co dopiero pomyśleć gdyby ktoś również korzystał z frameworka, który nie musi za każdym razem ładować setek swoich plików, tylko byłby natywnie dołączany do PHP… Sam byłem zachwycony, ale nie korzystałem.

Trafiła mi się sprawa związana z dłubaniem w aplikacji opartej o Phalcon 3. Wszystko wydawało się super dopóki zostawało sie na poziomie kontrolerów, widoków, podstawowej konfiguracji. Jak chciałem (musiałem) zrobić coś więcej – optymalizacja zarządzania sesją okazało się, że tutaj nie jest kolorowo. Zderzyłem się ze ścianą – Phalcon posiada nikłą dokumentację, moim zdaniem na poziomie Zend Framework 0.*.
Jest prosty guide, wygenerowany „phpdoc” na podstawie komentarzy klas i to wszystko. Chciałbyś poznać dokładną listę parametrów np. do Phalcon\Session\Adapter\Libmemcached – bez szans, chciałbyś zoptymalizować sposób łączenia sie z memcached itd. – bez szans.
Okazało się, że może jest to dobry framework, ale podstawowa wiedza rozsiana jest po forach internetowych, brak informacji od speców korzystających z niego do czegoś więcej niż CMS-y i proste serwisy.
Dla zainteresowanych warto przeczytać książkę Phalcon PHP Framework Documentation po francusku, ale przynosi trochę więcej wiedzy.

PHP Versions Grouped (May 2018)

Problem

Nie wiem czy pamiętacie, ale 2016 rok nie był rokiem PHP 7. Dlaczego? Mało narzędzi poprawnie współpracowało z PHP 7. W samym slniku dużo zostało zmienione i społeczność od PECL-i nie nadążyła. Firmy/Projekty dopiero robiły przymiarki, szczególnie gdy okazywało się, że aplikacje wymagały refactoringu, aby poprawnie działać na PHP 7 (usunięte rozszerzenia i SAPI w PHP 7.0).
W pewnym momencie okazało się, że memcached w końcu działa poprawnie z PHP 7 i poszło wszystko do przodu. Również w projektach, w których brałem udział.

Ale. Do tej pory nie spotkałem się z sytuacją, aby memcached nie mógł poprawnie zawiadywać sesjami i stanowił problem (chociaż są nowsze podejścia, np. Redis jak save_handler). Okazuje się, że PHP 7 w połączeniu z memcached w pewnych sytuacjach (duża ilość requestów „AJAX”) może rzucić:

Jeśli mamy wygłuszone błędy (produkcja) to może to pozostać niezauważone albo po prostu zniknąć w czeluściach logów. Tym bardziej, gdy dzieje się sporadycznie. Ale co właściwie się dzieje?

Rozwiązanie

Okazuje się, że podobny problem (wiele zapytań równoległych z JS „psuje” sesje) ma wiele osób w sieci już od 2016 roku, czyli momentu wydania modułu. Oczywiście można byłoby przepisać miejsca, gdzie wykorzystywana jest sesja i lepiej kontrolować przepływ informacji. Ale to zwiększa koszty pracy, jak również może powodować kolejne komplikacje.
Nie pomagało w tej sytuacji zamykanie sesji wcześniej (session_write_close()), ani inne wynalazki (np. nowość w PHP 7 session.lazy_write).
Okazuje się, że problem jest dość trywialny i dotyczy domyślnej wartości dla memcached.sess_lock_retries, która od początku wersji 3.0 była ustawiona na 5. Wydaje mi się, że niska wartość w połączeniu z PHP 7 i HTTP2 (jeden kanał do całej komunikacji, mniejsze zatory na zapytaniach) spowodowały ujawnienie błędu domyślnej konfiguracji. W połowie 2017 roku ukazał się odpowiedni Pull Request zmieniający domyslną wartość w INI, jak również w samym C

Ustawienie w aplikacji ini_set(‚memcached.sess_lock_retries’, 200) rozwiązało problem z lockowaniem się sesji, ale… Wyłącznie w przypadku natywnego rozwiązania, tj. $_SESSION (które bazuje na konfiguracji PHP).
Niestety wykorzystanie wspomnianego Phalcon\Session\Adapter\Libmemcached w aplikacji powoduje nadal ten sam błąd. Widać Phalcon (C) nie bierze pod uwagę konfiguracji pecl-memcached (C) i jedzie po swojemu.